/*
 Example key / store webapp using Go.
*/
package webhash

import (
	"html/template"
	"net/http"

	"appengine"
	"appengine/datastore"
)

func init() {
	http.HandleFunc("/", rootHandler)
}

type User struct {
	UserID string
	Value  string
}

func rootHandler(w http.ResponseWriter, r *http.Request) {
	c := appengine.NewContext(r)
	u := User{
		UserID: r.FormValue("userid"),
		Value:  r.FormValue("value"),
	}
	k := datastore.NewKey(c, "User", u.UserID, 0, nil)

	if u.Value == "" {
		datastore.Get(c, k, &u)
	} else {
		datastore.Put(c, k, &u)
	}

	rootTemplate.Execute(w, u.Value)

}

var rootTemplate = template.Must(template.New("root").Parse(rootTemplateHTML))

const rootTemplateHTML = `
<!DOCTYPE HTML>
<html>
	<head>
		<title>WebHash Go</title>
		<meta charset="utf-8">
	</head>
	<body>
		{{.}}
	</body>
</html>
`
